/********************************************************************************
*                                                                               *
*                      F X   M O V I E   M A N A G E R                          *
*                                                                               *
*********************************************************************************
* Copyright(C) 2008,2011 by Luigi Ziviani <ziviani_luigi@yahoo.it>.             *
* All Rights Reserved.                            version 5.3                   *
*********************************************************************************
* Id: movieinfodialog.cpp,                        2008/01/01                    *
*********************************************************************************
* This file is part of FXMOVIEMANAGER                                           *
* FXMOVIEMANAGER is free software; you can redistribute it and/or modify        *
* it under the terms of the GNU General Public License as published by          *
* the Free Software Foundation; either version 3 of the License, or             *
* (at your option) any later version.                                           *
*                                                                               *
* This program is distributed in the hope that it will be useful,               *
* but WITHOUT ANY WARRANTY; without even the implied warranty of                *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the                 *
* GNU General Public License for more details.                                  *
* You should have received a copy of the GNU General Public License             *
* along with this program; if not, write to the Free Software                   *
* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA     * 
********************************************************************************/

#include <xincs.h>
#include <fx.h>
#include "config.h"
#include "icons.h"
#include "MovieInfoDialog.h"

FXIMPLEMENT(MovieInfoDialog,FXDialogBox,NULL,0)

// Create properties dialog
MovieInfoDialog::MovieInfoDialog(FXWindow *own,const FXString& name,FXint w,FXint h):FXDialogBox(own,name,DECOR_TITLE|DECOR_BORDER|DECOR_RESIZE,0,0,w+4,0, 4,4,4,4, 4,4){

  accepticon=new FXGIFIcon(getApp(),m_accept);

  dialogframe=new FXVerticalFrame(this,LAYOUT_FILL_X|LAYOUT_FILL_Y|FRAME_THICK|FRAME_SUNKEN, 0,0,0,0, 0,0,0,0,0,0);

  // Image viewer
  imageframe=new FXImageFrame(dialogframe,NULL,LAYOUT_FILL_X|LAYOUT_FILL_Y,0,0,0,0, 0,0,0,0);

  new FXHorizontalSeparator(dialogframe,SEPARATOR_GROOVE|LAYOUT_SIDE_BOTTOM|LAYOUT_FILL_X);

  // text fields
  infoframe=new FXHorizontalFrame(dialogframe,LAYOUT_SIDE_BOTTOM|LAYOUT_FILL_X,0,0,0,0, 0,0,0,0);

  new FXLabel(infoframe,tr("Name:"),NULL,JUSTIFY_LEFT);
  infolist0=new FXLabel(infoframe,"",0,JUSTIFY_LEFT);
  new FXHorizontalSeparator(dialogframe,SEPARATOR_GROOVE|LAYOUT_SIDE_BOTTOM|LAYOUT_FILL_X);

  matrix=new FXMatrix(dialogframe,3,MATRIX_BY_COLUMNS|LAYOUT_FILL_X|LAYOUT_SIDE_BOTTOM,0,0,0,0, 0,0,0,0, 5,0);

  // information
  infolist1_1=new FXLabel(matrix,"",0,JUSTIFY_LEFT);
  infolist2_1=new FXLabel(matrix,"",0,JUSTIFY_LEFT);
  infolist3_1=new FXLabel(matrix,"",0,JUSTIFY_LEFT);

  infolist1_2=new FXLabel(matrix,"",0,JUSTIFY_LEFT);
  infolist2_2=new FXLabel(matrix,"",0,JUSTIFY_LEFT);
  infolist3_2=new FXLabel(matrix,"",0,JUSTIFY_LEFT);

  infolist1_3=new FXLabel(matrix,"",0,JUSTIFY_LEFT);
  infolist2_3=new FXLabel(matrix,"",0,JUSTIFY_LEFT);
  infolist3_3=new FXLabel(matrix,"",0,JUSTIFY_LEFT);

  infolist1_4=new FXLabel(matrix,"",0,JUSTIFY_LEFT);
  infolist2_4=new FXLabel(matrix,"",0,JUSTIFY_LEFT);
  infolist3_4=new FXLabel(matrix,"",0,JUSTIFY_LEFT);

  infolist1_5=new FXLabel(matrix,"",0,JUSTIFY_LEFT);
  infolist2_5=new FXLabel(matrix,"",0,JUSTIFY_LEFT);
  infolist3_5=new FXLabel(matrix,"",0,JUSTIFY_LEFT);

  infolist1_6=new FXLabel(matrix,"",0,JUSTIFY_LEFT);
  infolist2_6=new FXLabel(matrix,"",0,JUSTIFY_LEFT);
  infolist3_6=new FXLabel(matrix,"",0,JUSTIFY_LEFT);
  new FXHorizontalSeparator(dialogframe,SEPARATOR_GROOVE|LAYOUT_SIDE_BOTTOM|LAYOUT_FILL_X);

  infolong1=new FXLabel(dialogframe,"",0,JUSTIFY_LEFT);
  new FXHorizontalSeparator(dialogframe,SEPARATOR_GROOVE|LAYOUT_SIDE_BOTTOM|LAYOUT_FILL_X);
  infolong2=new FXLabel(dialogframe,"",0,JUSTIFY_LEFT);
  new FXHorizontalSeparator(dialogframe,SEPARATOR_GROOVE|LAYOUT_SIDE_BOTTOM|LAYOUT_FILL_X);
  infolong3=new FXLabel(dialogframe,"",0,JUSTIFY_LEFT);
  new FXHorizontalSeparator(dialogframe,SEPARATOR_GROOVE|LAYOUT_SIDE_BOTTOM|LAYOUT_FILL_X);

  // metadata
  infometadata = new FXLabel(dialogframe,"",0,JUSTIFY_LEFT);
  new FXHorizontalSeparator(dialogframe,SEPARATOR_GROOVE|LAYOUT_SIDE_BOTTOM|LAYOUT_FILL_X);

  // buttons
  buttonsframe=new FXHorizontalFrame(dialogframe,LAYOUT_SIDE_BOTTOM|LAYOUT_FILL_X|PACK_UNIFORM_WIDTH,0,0,0,0, 0,0,0,0);
  new FXButton(buttonsframe,tr(" &CLOSE "),accepticon,this,FXDialogBox::ID_ACCEPT,BUTTON_INITIAL|BUTTON_DEFAULT|BUTTON_NORMAL|LAYOUT_CENTER_X|LAYOUT_CENTER_Y);

  new FXSeparator(dialogframe,SEPARATOR_GROOVE|LAYOUT_FILL_X);
  FXHorizontalFrame *copyright=new FXHorizontalFrame(dialogframe,LAYOUT_BOTTOM|LAYOUT_FILL_X,0,0,0,0,5,5,5,5);
  FXLabel *label = new FXLabel(copyright,"FXMovieManager - Movie Information",NULL,LAYOUT_FILL_X|LAYOUT_CENTER_Y|JUSTIFY_LEFT,0,0,0,0,15);
  // set the same look of separators
  label->disable();        

  }


FXString MovieInfoDialog::timeConvert(long time) {

    int t_h, t_m, t_s;
    t_h = time/3600;
    t_m = time/60 - t_h*60;
    t_s = time - t_m*60 - t_h*3600;
    timeText=FXString::value(t_h)+"hr:"+FXString::value(t_m)+"min:"+FXString::value(t_s)+"sec";

  return timeText;
  }


void MovieInfoDialog::processFormat(AVFormatContext *pFormatCtx) {

    const char* fmt;
	FXString format;
    long time;

	fmt = pFormatCtx->filename;
    infolist0->setText(fmt);

	unsigned int strm = pFormatCtx->nb_streams;
	format = "N. "+FXString::value(strm)+" streams";
    infolist1_1->setText(format.text());

	int64_t sz = pFormatCtx->file_size;
	format = FXString::value(sz)+"kbit";
    infolist1_2->setText(format);

	fmt = pFormatCtx->iformat->name;
    infolist1_3->setText(fmt);

	time = pFormatCtx->bit_rate/1000;
    infolist1_4->setText((FXString::value(time)+"kbit/sec").text());

	time = pFormatCtx->start_time;
    time /=1000000;
	timeConvert(time);
    infolist1_5->setText(timeText.text());

	time = pFormatCtx->duration;
    time /=1000000;
	timeConvert(time);
    infolist1_6->setText(timeText.text());

	fmt = pFormatCtx->iformat->long_name;
	format="Format: "+(FXString)fmt;
    infolong1->setText(format);

  }


void MovieInfoDialog::processVideoStream(AVFormatContext *pFormatCtx, int stream_idx) {

	AVStream *stream = pFormatCtx->streams[stream_idx];
    AVCodecContext *pCodecCtx;
    AVCodec *pCodec;
	FXString form;
    const char* fmt;

	unsigned int strm = stream->index;
	form = "Stream "+FXString::value(strm);
   	infolist2_1->setText(form.text());

   	infolist2_2->setText("VIDEO");

    // Get a pointer to the codec context for the video stream
   	if (pCodecCtx = stream->codec) {
		
    	// Find the decoder for the stream
    	pCodec=avcodec_find_decoder(pCodecCtx->codec_id);

    	if(pCodec==NULL) {
        	return; // Codec not found
		} else {
			infolist2_3->setText(pCodec->name);

			fmt = pCodec->long_name;
			form="Video: "+(FXString)fmt;
    		infolong2->setText(form);
		}

		if(stream->avg_frame_rate.num != 0) {
			form = "Rate "+FXString::value(stream->avg_frame_rate.num)+"/"+FXString::value(stream->avg_frame_rate.den);
		} else {
			form = "Rate "+FXString::value(stream->r_frame_rate.num)+"/"+FXString::value(stream->r_frame_rate.den);
		}
		infolist2_4->setText(form);
		form = "Width "+FXString::value(pCodecCtx->width);
		infolist2_5->setText(form);
		form = "Height "+FXString::value(pCodecCtx->height);
		infolist2_6->setText(form);
	} else {
		return;
	}

  }

void MovieInfoDialog::processAudioStream(AVFormatContext *pFormatCtx, int stream_idx) {

	AVStream *stream = pFormatCtx->streams[stream_idx];
    AVCodecContext *pCodecCtx;
    AVCodec *pCodec;
	FXString form;
    const char* fmt;
	unsigned int strm = stream->index;

	form = "Stream "+FXString::value(strm);
   	infolist3_1->setText(form.text());
   	infolist3_2->setText("AUDIO");

    // Get a pointer to the codec context for the audio stream
   	if (pCodecCtx = stream->codec) {

    	// Find the decoder for the stream
    	pCodec=avcodec_find_decoder(pCodecCtx->codec_id);

    	if(pCodec==NULL) {
        	return; // Codec not found
		} else {
			infolist3_3->setText(pCodec->name);

			fmt = pCodec->long_name;
			form="Audio: "+(FXString)fmt;
    		infolong3->setText(form);
		}

		if(stream->avg_frame_rate.num != 0) {
			form = "Rate "+FXString::value(stream->avg_frame_rate.num)+"/"+FXString::value(stream->avg_frame_rate.den);
		} else {
			form = "Rate "+FXString::value(stream->r_frame_rate.num)+"/"+FXString::value(stream->r_frame_rate.den);
		}
		infolist3_4->setText(form);
		form = "Sampling "+FXString::value(pCodecCtx->sample_rate)+"Hrz";
       	infolist3_5->setText(form);
		form = "N. "+FXString::value(pCodecCtx->channels)+" channels";
       	infolist3_6->setText(form);
	} else {
		return;
	}

  }

void MovieInfoDialog::processMetadata(AVFormatContext *pFormatCtx) {

	FXString metadata;
	FXint tot = 40;
#ifdef HAVE_LIBAVUTIL
    AVDictionaryEntry *dict = NULL;
    while ((dict = av_dict_get(pFormatCtx->metadata, "", dict, AV_DICT_IGNORE_SUFFIX))) {
		metadata.append(dict->key);
		metadata.append(":");
		metadata.append(dict->value);
		if(metadata.count()<tot) {
			metadata.append(", ");
		} else {
			metadata.append("\n");
			tot+=40;
		}
	}
#endif
	infometadata->setText(metadata);
 
  }

void MovieInfoDialog::processFileName(const FXString& filename){

    AVFormatContext *pFormatCtx = NULL;
	int i;

#ifdef HAVE_LIBAVCODEC
    avcodec_register_all();
#endif
    // Register all formats and codecs
    av_register_all();

    // Open video file
    if(avformat_open_input(&pFormatCtx, filename.text(), NULL, NULL) < 0) {
		return; // Couldn't open file
	}

    // process stream information
    if(av_find_stream_info(pFormatCtx) < 0) {
        return; // Couldn't find stream information
	} else {
    	for (i = 0; i < pFormatCtx->nb_streams; i++) {
	        if(pFormatCtx->streams[i]->codec->codec_type==AVMEDIA_TYPE_VIDEO) {
        		processVideoStream(pFormatCtx, i);
        	}
			else if(pFormatCtx->streams[i]->codec->codec_type==AVMEDIA_TYPE_AUDIO) {
        		processAudioStream(pFormatCtx, i);
        	}
			else {
        		return;
			}
 		}
	}

    // close each decoder
    for (i = 0; i < pFormatCtx->nb_streams; i++) {
        avcodec_close(pFormatCtx->streams[i]->codec);
    }

    // process format information
    processFormat(pFormatCtx);

    // process metadata information
    processMetadata(pFormatCtx);

    // Additionally dump information about file onto standard error
    av_dump_format(pFormatCtx, 0, filename.text(), false);

   // Free context and all its streams 
    av_close_input_file(pFormatCtx);
	//avformat_free_context(pFormatCtx);
  }

// Destroy
MovieInfoDialog::~MovieInfoDialog(){
  delete imageframe->getImage();
  delete accepticon;

  }


